/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUTPAP_TIPOAJPAGAR                                          */
/* Tabela : TIPOAJPAGAR                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 26/02/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATUTPAP_TIPOAJPAGAR
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOAJPAGAR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPAP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDAJUCTPAG,0  ) <> NVL(:NEW.CDAJUCTPAG,0  )) OR
         (NVL(:OLD.CDHISTPADR,0  ) <> NVL(:NEW.CDHISTPADR,0  )) OR 
         (NVL(:OLD.CDCONTCTBL,0  ) <> NVL(:NEW.CDCONTCTBL,0  )) OR
         (NVL(:OLD.DSAJUCTPAG,0  ) <> NVL(:NEW.DSAJUCTPAG,0  )) OR 
         (NVL(:OLD.IDAJUCTPAG,0  ) <> NVL(:NEW.IDAJUCTPAG,0  )) THEN
         :NEW.DTULTATUTPAP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOAJPAGAR', '', 'CDAJUCTPAG='||:OLD.CDAJUCTPAG||';                                                                 CDHISTPADR='||:OLD.CDHISTPADR||';
                                CDCONTCTBL='||:OLD.CDCONTCTBL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOAJPAGAR MODIFY DTULTATUTPAP DEFAULT SYSDATE
/



-- VERSAO --
BEGIN ATUVEROBJ('DTULTATUTPAP_TIPOAJPAGAR','4.11.072'); END;
/

