/* Sistemas Integrados TEKNISA
    
Nome: 9502_CVIVIEO_ETL_CONTARECDTVENC

Descrio: view que retorna AS CONTAS A RECEBER EM ABERTO POR DATA DE VENCIMENTO DO BOLETO (ANO E MES)

Criao:
24/07/2012 - Ftima Fernandes
*/

CREATE OR REPLACE FORCE VIEW "DM_CONTARECDTVENC" ("CDEMPRESA", "CDFILIAL", "NMFILIALEMIT", 
"NMFANTCLIE", "NMRAZSOCCLIE", "NMTIPOCONTA", "CDANOBI", "CDMESBI", "STATUS", "DSDOCSERIE", "DSDESCRICAO", "DSSTCONTA", "VRBRUTOBOLETOREC", 
"VRLIQUIDOBOLETOREC", "VRAJUSTEBOLETOREC", "VRORIGREC", "VRAJUSTCTREC", "VRARECEBER", "QTCONTAS",  "QTDIASVENCTO",
 "DIASATRASO", "QTBOLEMATRASO")
AS
   SELECT  BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL || '-' || F.NMFILIAL AS NMFILIALEMIT, CL.NMFANTCLIE,
    CL.NMRAZSOCCLIE,  CT.CDTPCTRECEB || '-' || TP.DSTPCTRECEB AS NMTIPOCONTA, 
    TO_CHAR(BO.DTVENBOLREC, 'YYYY') AS CDANOBI,
    TO_CHAR(BO.DTVENBOLREC, 'MM') AS CDMESBI,
    (CASE WHEN TRUNC(BO.DTVENBOLREC) < TRUNC(SYSDATE) THEN 'VENCIDA' ELSE 'A VENCER'END) STATUS,
    (NF.NRNOTAFISC||'/'||NF.CDSERIE||' - Venc.:'||BO.DTVENBOLREC) DOC_SERIE,
    (CT.DSCONTAREC) DESCRICAO,
    DECODE (NF.IDSTATUS,'V','PREVISTA','REAL') AS DSSTCONTA,
    (ROUND(BO.VRBOLREC, 2)) VRBRUTOBOLETOREC,
    (ROUND(BO.VRFINALBREC, 2)) VRLIQUIDOBOLETOREC,
    (ROUND(BO.VRFINALBREC, 2) - ROUND(BO.VRBOLREC, 2)) VRAJUSTEBOLETOREC,
    SUM(ROUND(CT.VRORIGREC, 2)) VRORIGREC,
    SUM(ROUND(VRATUAREC, 2)- ROUND(CT.VRORIGREC, 2)) VRAJUSTCTREC,
    SUM(ROUND(CT.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CT.VRATUAREC/BO.VRBOLREC))) VRARECEBER,
    COUNT(*) AS QTCONTAS,
    (TRUNC(BO.DTVENBOLREC)  - TRUNC(NF.DTENTRSAID))  AS QTDIASVENCTO,
    (CASE WHEN TRUNC(BO.DTVENBOLREC) < TRUNC(SYSDATE) THEN ROUND(TRUNC(SYSDATE) - TRUNC(BO.DTVENBOLREC))  ELSE 0  END) DIASATRASO,
    (CASE WHEN TRUNC(BO.DTVENBOLREC) < TRUNC(SYSDATE) THEN 1 ELSE 0 END) QTBOLEMATRASO
    FROM CONTARECEBER CT, BOLETRECEBER BO, CLIENTE CL,
    TIPOCTRECEBER TP, NOTAFISCAL NF, FILIAL F 
  WHERE BO.CDFILIAL   = CT.CDFILIBOLREC
  AND BO.NRLANBOLREC  = CT.NRLANBOLREC
  AND CT.IDSTATREC = 'A'
  AND CT.VRATUAREC <> 0
  AND CL.CDCLIENTE    = BO.CDCLIENTE
  AND TP.CDTPCTRECEB  = CT.CDTPCTRECEB 
  AND CT.NRLANCTONF   = NF.NRLANCTONF
  AND CT.CDFILIAL     = NF.CDFILIAL
  AND NF.CDFILIEMIT   = F.CDFILIAL
  GROUP BY BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL, F.NMFILIAL, 
  CL.NMFANTCLIE, CL.NMRAZSOCCLIE, CT.CDTPCTRECEB, TP.DSTPCTRECEB, 
  BO.VRBOLREC, BO.VRFINALBREC, BO.DTVENBOLREC, NF.DTENTRSAID,NF.IDSTATUS, NF.NRNOTAFISC, NF.CDSERIE, CT.DSCONTAREC
/

BEGIN
--Fatos--	
	CRIA_FATOS('DM_CONTARECDTVENC', 'VRBRUTOBOLETOREC'  ,'Vr. Bruto do Boleto.'			,'Valor Bruto do Boleto'	      		,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'VRLIQUIDOBOLETOREC','Vr. Lq. do Boleto.'			,'Valor Lquido do Boleto'	      		,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'VRAJUSTEBOLETOREC'	,'Vr. de Ajuste do Boleto.'		,'Valor de Ajuste Boleto'	      		,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'VRORIGREC'			,'Vr. Orig. Conta a Receber.'	,'Valor Inicial da conta a Receber'	    ,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'VRAJUSTCTREC'		,'Vr. de Ajuste Contas a Rec.'	,'Valor de Ajuste de Contas a Receber'	,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'VRARECEBER'		,'Vr. a Receber.'				,'Valor a Receber'		      			,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'QTCONTAS'   		,'Quant. de Contas.'			,'Quantidade de Contas'			   		,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'QTDIASVENCTO'		,'Dias p/ o Venc.'				,'Quantidade de Dias para o venc.'    	,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'DIASATRASO'		,'Dias em Atraso.'				,'Quantidade de Dias em o Atraso'     	,'Cont. a Rec. - Data de Venc.');
	CRIA_FATOS('DM_CONTARECDTVENC', 'QTBOLEMATRASO'    ,'Quant. de Boleto em atraso'	,'Quantidade de Boleto em o Atraso'   	,'Cont. a Rec. - Data de Venc.');

--Dimenso
	CRIA_DIME('DM_CONTARECDTVENC'	,'CDEMPRESA'	,'Empresa'				,'EMPRESA','CDEMPRESA'	  	,'NMEMPRESA'	  	,NULL);
	CRIA_DIME('DM_CONTARECDTVENC'	,'CDFILIAL'		,'Filial'				,'FILIAL' ,'CDFILIAL' 	  	,'NMFILIAL' 	  	,NULL);
 CRIA_DIME('DM_CONTARECDTVENC'	,'NMFILIALEMIT'	,'Filial de Emisso'	,NULL	  ,NULL		  		,NULL		  		,NULL);
 CRIA_DIME('DM_CONTARECDTVENC'	,'NMFANTCLIE'	,'Nome Fantasia'		,NULL	  ,NULL		  		,NULL		  		,NULL);
 CRIA_DIME('DM_CONTARECDTVENC'	,'NMRAZSOCCLIE'	,'Razo Social'			,NULL	  ,NULL		  		,NULL		  		,NULL);
	CRIA_DIME('DM_CONTARECDTVENC'	,'NMTIPOCONTA'	,'Tipo de Conta'		,NULL	  ,NULL		  		,NULL		  		,NULL);
	CRIA_DIME('DM_CONTARECDTVENC'	,'CDANOBI'		,'Ano'					,NULL	  ,NULL		  		,NULL		  		,NULL);
 CRIA_DIME('DM_CONTARECDTVENC'	,'CDMESBI'		,'Ms'					,NULL	  ,NULL		  		,NULL		  		,NULL);
	CRIA_DIME('DM_CONTARECDTVENC'	,'DSSTCONTA'	,'Situao da Conta'	,NULL	  ,NULL		  		,NULL		  		,NULL);
 CRIA_DIME('DM_CONTARECDTVENC'	,'STATUS'	,'Status'	,NULL	  ,NULL		  		,NULL		  		,NULL);
 CRIA_DIME('DM_CONTARECDTVENC'	,'DSDOCSERIE'	,'Doc/Srie'	,NULL	  ,NULL		  		,NULL		  		,NULL);
 CRIA_DIME('DM_CONTARECDTVENC'	,'DSDESCRICAO'	,'Descrio'	,NULL	  ,NULL		  		,NULL		  		,NULL);
END;
/
	
-- VERSAO --
BEGIN ATUVEROBJ('DM_CONTARECDTVENC','5.09.105'); END;
/