/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PARAVEND                                                 */
/* Tabela : PARAVEND                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PARAVEND'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PARAVEND
GO

CREATE TRIGGER DTULTATU_PARAVEND
ON PARAVEND
FOR INSERT, UPDATE, DELETE
AS
DECLARE @V_IDUT VARCHAR(1);
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PARAVEND', CDFILIAL, 'CDFILIAL='+ CDFILIAL+';'+'CDPARAVEND='+CDPARAVEND+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      IF (0 = (SELECT COUNT(*) FROM DELETED)) BEGIN
         SELECT  @V_IDUT = MAX(P.IDUTMODPRODFIL)
           FROM PARAMFILIAL P, INSERTED
          WHERE P.CDFILIAL = INSERTED.CDFILIAL;
          UPDATE PARAVEND
             SET DTULTATUPAVN   = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)),
                 IDUTILMODPROD  = @V_IDUT
            FROM INSERTED
           WHERE (ISNULL(PARAVEND.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0));
      END
      ELSE BEGIN
        UPDATE PARAVEND
           SET DTULTATUPAVN   = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
          FROM INSERTED
         WHERE (ISNULL(PARAVEND.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0));
      END;
   END;
END;
GO

UPDATE PARAVEND SET DTULTATUPAVN = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPAVN IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPAVN' and
            type = 'D')
   ALTER TABLE PARAVEND DROP CONSTRAINT DEFAULT_DTULTATUPAVN
GO

ALTER TABLE PARAVEND ADD CONSTRAINT DEFAULT_DTULTATUPAVN
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPAVN
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PARAVEND','5.07.026';
GO

